      SUBROUTINE BKGDMN(NF,NE,NS,S,OPT,IND,COVSEL,LDCVSL,
     .     LONSEL,LATSEL,VERB,XSW,YSW,XNE,YNE,ANGLE,NX,NY,
     .     DX,DY,XG,YG,ZG,LDZG,VARG,LDVARG,DOG,LDDOG,LON,LAT,Z,
     .     EXTRAP,N,COVTYPE,COVPAR,COVMAT,LDCOV,C0VEC,COV0,
     .     EXTCOV,TREND,NTREND,MUPR,LDMPR,
     .     PHIPR,LDPHPR,LONPR,LATPR,NPR,TYPPR,
     .     RSEARCH, NSEARCH, NSMIN, NSMAX, LWORK, MODE,MU,LAMBDA,LAMBD0,
     .     IERR,GLSMTH)
*
*  -- user defined driver routine --   
*     
*
      IMPLICIT NONE
*     .. Scalar Arguments ..
      INTEGER NF, NE, NS, NX, NY, VERB, LDCVSL,
     .     LDCOV, LDMPR, LDPHPR, LDZG, LDVARG, LDDOG,
     .     IERR, EXTRAP, COVTYPE, EXTCOV, TREND, NTREND, NSEARCH,
     .     NSMIN, NSMAX, NPR, MODE, GLSMTH, LWORK, N
      DOUBLE PRECISION OPT, LAMBD0, COV0, XSW, YSW, XNE, YNE, ANGLE, 
     .     DX, DY, RSEARCH
*     .. Array Arguments ..
      INTEGER S(*), IND(*), DOG(LDDOG,*), TYPPR(*)
      DOUBLE PRECISION COVSEL(LDCVSL,*), LONSEL(*), LATSEL(*),
     .     XG(*), YG(*), ZG(LDZG,*), VARG(LDVARG,*), LON(*), LAT(*),
     .     Z(*), COVMAT(LDCOV,*),C0VEC(*), MU(*), LAMBDA(*),
     .     COVPAR(*), MUPR(LDMPR,*), PHIPR(LDPHPR,*), LONPR(*), LATPR(*)


c     local variables
      INTEGER            I, J, K, L, M, CARDS, JMIN, JMAX,
     .                   NA, COUNT, NI, NKMEAN, SEARCHNB(1), RETLM
      DOUBLE PRECISION   KMEAN, KMIN
*     ..
*     .. Local Arrays ..
*     ..
*     .. External Functions ..
*     ..
*     .. External Subroutines ..
      EXTERNAL           BK_GRID, PSUBM, PIND
*     ..
*     .. Intrinsic Functions ..
*     ..
*     .. Executable Statements ..
*
*
* Initializing
 
      NA=N
      RETLM=0
      DO 10 I=1,NE
         S(I)=I+NF
 10   CONTINUE

      DO 11 I=1,NF
         IND(I)=I
         LONSEL(I)=LON(I)
         LATSEL(I)=LAT(I)
 11   CONTINUE
      
      DO 12 I=NF+1,NA
         IND(I)=0
         LONSEL(I)=0
         LATSEL(I)=0
 12   CONTINUE
      JMAX=1

* Main loop

 20   CONTINUE

* Computation of the cardinality of the actual solution
 
      CARDS=NF
      DO 21 I=1,NE
         IF (S(I).NE.0) THEN
            CARDS=CARDS+1
         ENDIF
 21   CONTINUE

* Is the actual solution S feasible?

      IF (CARDS.GT.(NF+NS)) THEN 
         GOTO 22
      ELSE
         GOTO 30
      ENDIF
 22   CONTINUE

* Computation of the actual index set IND
 
      K=NF+1
      DO 221 I=JMAX,NE
         IF (S(I).NE.0 .AND. I.NE.JMAX) THEN
            IND(K)=S(I)
            K=K+1
         ENDIF
 221   CONTINUE

* Computation of the maximal krige variance of the actual 
* infeasible solution 

       NI=K-1
       DO 222 L=NF+1,NI
          LONSEL(L)=LON(IND(L))
          LATSEL(L)=LAT(IND(L))
 222   CONTINUE
       CALL PSUBM(COVMAT,NA,NA,COVSEL,NA,IND,NI)
          CALL BK_GRID(XSW, YSW, XNE, YNE, ANGLE, NX, NY, DX, DY, XG, 
     .           YG, ZG, VARG, DOG, LONSEL, LATSEL, Z, EXTRAP, NI, 
     .           COVTYPE, COVPAR, COVSEL, LDCVSL, EXTCOV, TREND, NTREND,
     .           MUPR, LDMPR, PHIPR, LDPHPR, LONPR, LATPR, NPR, TYPPR,
     .           RSEARCH, NSEARCH, NSMIN, NSMAX, LWORK, MODE,
     .           MU, LAMBDA, LAMBD0, SEARCHNB, IERR, RETLM, GLSMTH)


            KMEAN=0.0D0
            NKMEAN=0
            DO 223 L=1,NX
               DO 224 M=1,NY 
                  IF(DOG(L,M).EQ.1) THEN
                     KMEAN=KMEAN+VARG(L,M)
                     NKMEAN=NKMEAN+1
                  ENDIF
 224              CONTINUE
 223        CONTINUE

            KMIN=KMEAN/NKMEAN
            JMIN=JMAX
      if (verb.eq.1) write (*,*) 'no of comb. / card of selection. / mea
     .n variance:', count, '/', cards, '/', kmean

* Selecting a station as candidate to reduce the network
* Computation of the maximum krige variance of the resulting network 

      DO 23 J=JMAX,NE
         IF (S(J) .NE. 0) THEN 
            K=NF+1
            DO 230 I=JMAX,NE
               IF(S(I).NE.0 .AND. I.NE.J) THEN
                  IND(K)=S(I)
                  K=K+1
               ENDIF
 230        CONTINUE
            NI=K-1

            DO 231 L=NF+1,NI
               LONSEL(L)=LON(IND(L))
               LATSEL(L)=LAT(IND(L))
 231        CONTINUE
            CALL PSUBM(COVMAT,NA,NA,COVSEL,NA,IND,NI)
          CALL BK_GRID(XSW, YSW, XNE, YNE, ANGLE, NX, NY, DX, DY, XG, 
     .           YG, ZG, VARG, DOG, LONSEL, LATSEL, Z, EXTRAP, NI, 
     .           COVTYPE, COVPAR, COVSEL, LDCVSL, EXTCOV, TREND, NTREND,
     .           MUPR, LDMPR, PHIPR, LDPHPR, LONPR, LATPR, NPR, TYPPR,
     .           RSEARCH, NSEARCH, NSMIN, NSMAX, LWORK, MODE,
     .           MU, LAMBDA, LAMBD0, SEARCHNB, IERR, RETLM, GLSMTH)
            
*     Determining the maximal krige variance for the actual selection 

            KMEAN=0.0D0
            NKMEAN=0
            DO 24 L=1,NX
               DO 25 M=1,NY 
                  IF(DOG(L,M).EQ.1) THEN
                     KMEAN=KMEAN+VARG(L,M)
                     NKMEAN=NKMEAN+1
                  ENDIF
 25            CONTINUE
 24         CONTINUE
            KMEAN=KMEAN/NKMEAN

*            write (*,*) 'kmax:', kmax 
            
            IF (KMEAN.LE.KMIN) THEN
               KMIN=KMEAN
               JMIN=J
            ENDIF
         ENDIF 
 23   CONTINUE

* Deleting the station JMIN from the current network   

      S(JMIN)=0

* Determining the station with the smallest index in the current network   

      IF (JMIN.EQ.JMAX) THEN
         DO 232 J=JMIN+1,NE
            IF (S(J).NE.0) THEN
               GOTO 233
            ENDIF
 232     CONTINUE
 233     JMAX=J         
      ENDIF

      GOTO 20

* Greedy solution found

 30   CONTINUE

* Calculating krige prediction and krige variance for the greedy solution

      NI=NF+NS
      CALL PIND(S,IND,NA,NE,NF,NI)
      DO 40 L=NF+1,NI
         LONSEL(L)=LON(IND(L))
         LATSEL(L)=LAT(IND(L))
 40   CONTINUE
      CALL PSUBM(COVMAT,NA,NA,COVSEL,NA,IND,NI)
          CALL BK_GRID(XSW, YSW, XNE, YNE, ANGLE, NX, NY, DX, DY, XG, 
     .           YG, ZG, VARG, DOG, LONSEL, LATSEL, Z, EXTRAP, NI, 
     .           COVTYPE, COVPAR, COVSEL, LDCVSL, EXTCOV, TREND, NTREND,
     .           MUPR, LDMPR, PHIPR, LDPHPR, LONPR, LATPR, NPR, TYPPR,
     .           RSEARCH, NSEARCH, NSMIN, NSMAX, LWORK, MODE,
     .           MU, LAMBDA, LAMBD0, SEARCHNB, IERR, RETLM, GLSMTH)


      OPT=KMIN
      RETURN
      END 
      
