      SUBROUTINE KGRMX(NF,NE,NS,S,OPT,IND,
     .                  XSW,YSW,XNE,YNE,ANGLE,NX,NY,
     .                  DX,DY,XG,YG,ZG,VARG,DOG,
     .                  LON,LAT,Z,EXTRAP,N,
     .                  COVTYPE,COVPAR,COV,C0,COV0,EXTCOV,TREND,
     .                  NTREND,RSEARCH,NSEARCH,NSMIN,NSMAX,FWORK,F0WORK,
     .                  DIST,INDSNB,INDSNA,INDSRT,KWORK,NKWORK,RHSWORK,
     .                  IPIV,MODE,MU,LAMBDA,BITS,
     .                  IERR,LCOV,LLON,LLAT,VERB)
      IMPLICIT NONE
*
*  -- user defined driver routine --   
*     
*
*     .. Scalar Arguments ..
      INTEGER NF, NE, NS, NX, NY, N, VERB, 
     .        COVTYPE, EXTCOV, TREND, NTREND, NKWORK,
     .        NSEARCH, NSMIN, NSMAX, MODE, IERR, IPT, EXTRAP
      DOUBLE PRECISION OPT, XSW, YSW, XNE, YNE, ANGLE, DX, DY, RSEARCH
*     .. Array Arguments ..
      INTEGER S(*), IND(*), INDSNB(*), INDSNA(*), INDSRT(*),
     .        IPIV(*),DOG(NX,*),BITS(*)
      DOUBLE PRECISION XG(*), YG(*), ZG(NX,*), VARG(NX,*),
     .                 LON(*), LAT(*), Z(*), COV(N,*), C0(*), COV0(*),
     .                 FWORK(N,*), F0WORK(NTREND,*), DIST(*),
     .                 KWORK(NKWORK,*), RHSWORK(*), MU(*), LAMBDA(*),
     .                 COVPAR(*), LCOV(N,*), LLON(*), LLAT(*)

c     local variables
      INTEGER            I, J, K, CARDS, IMIN, NA, COUNT, LDCOV, NI,
     .                   RETLM
      DOUBLE PRECISION   KMAX1, KMAX, KMIN
*     ..
*     .. Local Arrays ..
*     ..
*     .. External Functions ..
*     ..
*     .. External Subroutines ..
      EXTERNAL           KRIGE_GRID, PSUBM, PIND
*     ..
*     .. Intrinsic Functions ..
*     ..
*     .. Executable Statements ..
*
*
* Initializing
 
      RETLM=0

      LDCOV=N
      NA=N
      DO 10 I=1,NE
         S(I)=0
 10   CONTINUE

      DO 11 I=1,NF
         IND(I)=I
         LLON(I)=LON(I)
         LLAT(I)=LAT(I)
 11   CONTINUE
      
      DO 12 I=NF+1,NA
         IND(I)=0
         LLON(I)=0
         LLAT(I)=0
 12   CONTINUE
      IMIN=1


* Main loop

 20   CONTINUE

* Computation of the actual index set IND and its cardinality
 
      K=NF+1
      CARDS=NF
      DO 21 I=1,NE
         IF (S(I).NE.0) THEN
            CARDS=CARDS+1
            IND(K)=S(I)
            K=K+1
         ENDIF
 21   CONTINUE

* Is the actual solution S feasible?

      IF (CARDS.LT.(NF+NS)) THEN 
         GOTO 22
      ELSE
         GOTO 30
      ENDIF
 22   CONTINUE

      

* Selecting a station as candidate for augmenting the network
* Computation of the krige variance of the resulting network 

      COUNT=1
      DO 23 I=1,NE
         IF (S(I) .EQ. 0) THEN 
            S(I)=NF+I
            CALL PIND(S,IND,NA,NE,NF,NI)
            DO 230 J=NF+1,NI
               LLON(J)=LON(IND(J))
               LLAT(J)=LAT(IND(J))
 230        CONTINUE
            CALL PSUBM(COV,NA,NA,LCOV,NA,IND,NI)

      CALL KRIGE_GRID(XSW,YSW,XNE,YNE,ANGLE,NX,NY,
     .     DX,DY,XG,YG,ZG,VARG,DOG,
     .     LLON,LLAT,Z,EXTRAP,NI,
     .     COVTYPE,COVPAR,LCOV,LDCOV,EXTCOV,TREND,
     .     NTREND,RSEARCH,NSEARCH,NSMIN,NSMAX,MODE,MU,LAMBDA,BITS,
     .     RETLM,IERR)
*     Determining the maximal krige variance for the actual selection 

            KMAX=0.0D0
            DO 24 J=1,NX
               DO 25 K=1,NY 
                  IF(DOG(J,K).EQ.1) THEN
                     KMAX1=VARG(J,K)
                     IF (KMAX1 .GE. KMAX) THEN
                        KMAX=KMAX1
                     ENDIF
                  ENDIF
 25            CONTINUE
 24         CONTINUE
      if (verb.eq.1) write (*,*) 'no of comb. / card of selection. / max
     . variance:', count, '/', cards, '/', kmax
            
*     Determining the minimum of the maximal krige variance for the 
*     actual selection and storing the index for which the maximal 
*     krige variance attained its minimum

            IF (COUNT .EQ. 1) THEN
               KMIN=KMAX
               IMIN=I
            ELSE
               IF (KMAX .LE. KMIN) THEN
                  KMIN=KMAX
                  IMIN=I
               ENDIF
            ENDIF
            S(I)=0
            CALL PIND(S,IND,NA,NE,NF,NI)
            COUNT=COUNT+1
         ENDIF 
 23   CONTINUE

* Augmenting the network selecting the station IMIN

      S(IMIN)=NF+IMIN
      GOTO 20

* Greedy solution found

 30   CONTINUE

* Calculating krige prediction and krige variance for the greedy solution

      CALL PIND(S,IND,NA,NE,NF,NI)
      DO 40 I=NF+1,NI
         LLON(I)=LON(IND(I))
         LLAT(I)=LAT(IND(I))
 40   CONTINUE
      CALL PSUBM(COV,NA,NA,LCOV,NA,IND,NI)
      CALL KRIGE_GRID(XSW,YSW,XNE,YNE,ANGLE,NX,NY,
     .     DX,DY,XG,YG,ZG,VARG,DOG,
     .     LLON,LLAT,Z,EXTRAP,NI,
     .     COVTYPE,COVPAR,LCOV,LDCOV,EXTCOV,TREND,
     .     NTREND,RSEARCH,NSEARCH,NSMIN,NSMAX,MODE,MU,LAMBDA,BITS,
     .     RETLM,IERR)
            
      OPT=KMIN
      RETURN
      END 
      
